int Translate(void)
{
	GPR[0]=0;
	Ops.op=Instruction >> 26;
	Ops.rs=(Instruction << 6) >> 27;
	Ops.rt=(Instruction << 11) >> 27;
	Ops.immediate=(Instruction << 16) >> 16;
	Ops.target=(Instruction << 6) >> 6;
	Ops.rd=(Instruction << 16) >> 27;
	Ops.sa=(Instruction << 21) >> 28;
	Ops.funct=(Instruction << 26) >> 26;
	Ops.code=(Instruction << 6) << 12;
	Ops.codea=(Instruction << 16)  >> 22;
	Ops.codeb=(Instruction << 21) >> 21;
	
 switch (Ops.op)
 {
 case ANDI:
	 // ANDI adds immediate to the last 16 bits of the value in register
	 // rs and stores the result in register rt
	 // This instruction does not generate an exception
	 GPR[Ops.rt]=Ops.immediate & ((GPR[Ops.rs] << 48) >> 48);
	 PC=PC+4;
	 return 0;
	 break;
 case COP1:
	 switch(Ops.funct)
	 {
	 case ABS:
		 switch(Ops.rs)
		 {
		 case SINGLE:
			 FPR[Ops.sa]=fabs(FPR[Ops.rd]);
			 //strcpy(OC, "ABS.S");
			 return 0;
			 break;
		 case DOUBLE:
			 FPR[Ops.sa]=fabs(FPR[Ops.rd]);
			 //strcpy(OC, "ABS.D");
			 return 0;
			 break;
		 }
		 PC=PC+4;
		 return 0;
		 break;
	 default:
		 strcpy(OC, "Unknown CP");
		 return -1;
		 break;
	 } 
	break;
	 case J:
		 // J left shifts target by two bits and adds it to the first four
		 // bits of PC. The result is stored in PC and a delay slot is 
		 // executed
		 // This instruction does not generate an exception
		 strcpy(OC, "J");
		 DelayPC=PC+4;
		 Delay=1;
		 PC=(_int32)((PC>>28) << 32) + (Ops.target << 2);
		 PC=PC+4;
		 return 0;
		 break;
 case BEQ:
	 // BEQ left shifts immediate by two bits, sign extends it, and adds
	 // the result to PC and stores it in PC if the values of register rs
	 // and register rt are equal. There is a delay of one instruction. 
	 // This instruction does not generate an exception
	 if(GPR[Ops.rs] == GPR[Ops.rt])
	 {
		Delay=1;
		DelayPC=PC+4;
		PC=DelayPC+((signed _int16)(Ops.immediate) << 2);
	 }
	 PC=PC+4;
	 return 0;
	 break;
 case JAL:
	 // JAL left shifts target by two bits and adds it to the first four
	 // bits of PC. The result is stored in PC and a delay slot is 
	 // executed. The address of the instruction after the delay slot is
	 // stored in General Purpose Register 31
	 // This instruction does not generate an exception
	 DelayPC=PC+4;
	 Delay=1;
	 GPR[31]=PC+8;
	 PC=(_int32)((PC>>28) << 32) + (Ops.target << 2);
	 PC=PC+4;
	 return 0;
	 break;
 case LDL:
	 strcpy(OC, "LDL");
	 PC=PC+4;
	 return -1;
	 break;
 case LDR:
	 strcpy(OC, "LDR");
	 PC=PC+4;
	 return -1;
	 break;
 case LH:
	 strcpy(OC, "LH");
	 PC=PC+4;
	 return -1;
	 break;
 case LW:
     //strcpy(OC,"LW");
     four[0]=ReadMemory((signed)Ops.immediate+GPR[Ops.rs], hWndMain);
     four[1]=ReadMemory((signed)Ops.immediate+GPR[Ops.rs]+1, hWndMain);
     four[2]=ReadMemory((signed)Ops.immediate+GPR[Ops.rs]+2, hWndMain);
     four[3]=ReadMemory((signed)Ops.immediate+GPR[Ops.rs]+3, hWndMain);
     GPR[Ops.rt]=((four[0] << 24) + (four[1] << 16) + (four[2] << 8) + four[3]);
     PC=PC+4;
	 return 0;
     break;
 case LB:
     //strcpy(OC,"LB");
     GPR[Ops.rt]=(char)(ReadMemory(Ops.rs+Ops.immediate,hWndMain));    
     PC=PC+4;
	 return 0;
     break;
 case LBU:
	 //strcpy(OC,"LBU");
     GPR[Ops.rt]=(unsigned char)ReadMemory(Ops.rs+Ops.immediate,hWndMain);
     PC=PC+4;
     return 0;
	 break;
  case LD:
     //strcpy(OC,"LD");
     eight[0]=ReadMemory(Ops.rs+Ops.immediate,hWndMain);
     eight[1]=ReadMemory(Ops.rs+Ops.immediate+1,hWndMain);
     eight[2]=ReadMemory(Ops.rs+Ops.immediate+2,hWndMain);
     eight[3]=ReadMemory(Ops.rs+Ops.immediate+3,hWndMain);
     eight[4]=ReadMemory(Ops.rs+Ops.immediate+4,hWndMain);
     eight[5]=ReadMemory(Ops.rs+Ops.immediate+5,hWndMain);
     eight[6]=ReadMemory(Ops.rs+Ops.immediate+6,hWndMain);
     eight[7]=ReadMemory(Ops.rs+Ops.immediate+7,hWndMain);
     GPR[Ops.rt]=((eight[0] << 56) + (eight[1] << 48) + (eight[2] << 40) + (eight[3] << 32) + (eight[4] << 24) + (eight[5] << 16) + (eight[6] << 8) + eight[7]);
     PC=PC+4;
     return 0;
	 break;
  case BNE:
	 // BNE. If registers rt and rs are not equal then immediate is sign 
	 // extended, left shifted two bits, and added to PC. There is a delay
	 // of one instruction.
	 // This instruction does not generate an exception
	 Delay=1;
	 DelayPC=PC+4;
	  if(GPR[Ops.rt] != GPR[Ops.rs])
	 {
	 	
		PC=PC+((signed _int16)(Ops.immediate)<<2);
	 }
	 PC=PC+4;
	 return 0;
	 break;
  case SW:
	 //strcpy(OC,"SW");
	 four[0]=(_int8)(GPR[Ops.rt] >> 24);
	 four[1]=(_int8)((GPR[Ops.rt] << 8) >> 24);
	 four[2]=(_int8)((GPR[Ops.rt] << 16) >> 24);
	 four[3]=(_int8)((GPR[Ops.rt] << 24) >> 24);
	 WriteMemory(((signed _int16)Ops.immediate+GPR[Ops.rs]),four[0],hWndMain);
	 WriteMemory(((signed _int16)Ops.immediate+GPR[Ops.rs]+1),four[1],hWndMain);
	 WriteMemory(((signed _int16)Ops.immediate+GPR[Ops.rs]+2),four[2],hWndMain);
	 WriteMemory(((signed _int16)Ops.immediate+GPR[Ops.rs]+3),four[3],hWndMain);
	 PC=PC+4;
	 return 0;
     break;
 case ORI:
	 //strcpy(OC,"ORI");
     GPR[Ops.rt]=(GPR[Ops.rs] | Ops.immediate);
	 PC=PC+4;
	 return 0;
	 break;
  case ADDI:
	 //strcpy(OC,"ADDI");
	 GPR[Ops.rt]=GPR[Ops.rs] + (signed _int16)Ops.immediate;
	 PC=PC+4;
	 return 0;
	 break;
 case ADDIU:
	 //strcpy(OC, "ADDIU");
	 GPR[Ops.rt]=(GPR[Ops.rs] + (signed _int16)Ops.immediate);
	 PC=PC+4;
	 return 0;
	 break;
 case CACHE:
	 //strcpy(OC, "CACHE");
	 PC=PC+4;
	 return 0;
	 break;
 case LUI:
	 //strcpy(OC, "LUI");
	 GPR[Ops.rt]=(signed _int64)(Ops.immediate << 16);
	 PC=PC+4;
	 return 0;
	 break;
 case 16:
	 switch(Ops.rs)
	 {
	 case MTC0:
	 //strcpy(OC, "MTC0");
	 CP0[Ops.rd]=GPR[Ops.rt];
	 PC=PC+4;
	 return 0;
	 break;
	 }
	 break;
 case 0:
	 switch (Ops.funct)
	 {
	 case SYNC:
		//strcpy(OC,"SYNC");
		PC=PC+4;
		return 0;
		break;
	 case ADD:
		//strcpy(OC,"ADD");
		GPR[Ops.rd] = GPR[Ops.rs] + GPR[Ops.rt];
		PC=PC+4; 
		return 0;
		break;
	 case ADDU:
		//strcpy(OC,"ADDU");
		GPR[Ops.rd] =(unsigned)(GPR[Ops.rs] + GPR[Ops.rt]);
		PC=PC+4;
		return 0;
		break;
	 case AND:
		//strcpy(OC,"AND");
        GPR[Ops.rd] = GPR[Ops.rs] & GPR[Ops.rt];
		PC=PC+4;
		return 0;
		break;
	 case DADD:
		 //strcpy(OC,"DADD");
		 GPR[Ops.rd] = GPR[Ops.rs] + GPR[Ops.rt];
		 PC=PC+4;
		 return 0;
		 break;
	 case DADDU:
		 //strcpy(OC,"DADDU");
		 GPR[Ops.rd] =(unsigned) GPR[Ops.rs] + GPR[Ops.rt];
		 PC=PC+4;
		 return 0;
		 break;
	 case DDIV:
		//strcpy(OC,"DDIV");
		LO=GPR[Ops.rs]/GPR[Ops.rt];
		HI=GPR[Ops.rs]%GPR[Ops.rt];
		PC=PC+4;
		return 0;
		break;
	 case DDIVU:
		 strcpy(OC,"DDIVU");
		 PC=PC+4;
		 return -1;
		 break;
	 case DIV:
		 strcpy(OC,"DIV");
		 PC=PC+4;
		 return -1;
		 break;
	 case DIVU:
		 strcpy(OC,"DIVU");
		 PC=PC+4;
		 return -1;
		 break;
	 case DSLL:
		 strcpy(OC,"DSLL");
		 PC=PC+4;
		 return -1;
		 break;
	 case DSLL32:
		 strcpy(OC,"DSLL32");
		 PC=PC+4;
		 return -1;
		 break;
	 case DSLLV:
		 strcpy(OC,"DSLLV");
		 PC=PC+4;
		 return -1;
		 break;
	 case 59:
		 strcpy(OC,"DSRA");
		 PC=PC+4;
		 return -1;
		 break;
	 case DSRA32:
		 //strcpy(OC,"DSRA32");
		 GPR[Ops.rd]=GPR[Ops.rt] >> (Ops.sa +32);
		 PC=PC+4;
		 return 0;
		 break;
	 case 23:
		 strcpy(OC,"DSRAV");
		 PC=PC+4;
		 return -1;
		 break;
	 case 58:
		 strcpy(OC,"DSRL");
		 PC=PC+4;
		 return -1;
		 break;
	 case 62:
		 strcpy(OC,"DSRL32");
		 PC=PC+4;
		 return -1;
		 break;
	 case 22:
		 strcpy(OC,"DSRLV");
		 PC=PC+4;
		 return -1;
		 break;
	 case 46:
		 //strcpy(OC,"DSUB");
		 GPR[Ops.rd] = GPR[Ops.rs] - GPR[Ops.rt];
		 PC=PC+4;
		 return 0;
		 break;
	 case 47:
		 //strcpy(OC,"DSUBU");
		 GPR[Ops.rd] =(unsigned)GPR[Ops.rs] - GPR[Ops.rt];
		 PC=PC+4;
		 return 0;
		 break;
	 case 16:
		 //strcpy(OC,"MFHI");
		 GPR[Ops.rd]=HI;
		 PC=PC+4;
		 return 0;
		 break;
	 case MFLO:
		 //strcpy(OC,"MFLO");
		 GPR[Ops.rd]=LO;
		 PC=PC+4;
		 return 0;
		 break;
	 case MTHI:
		 //strcpy(OC,"MTHI");
		 HI=GPR[Ops.rs];
		 PC=PC+4;
		 return 0;
		 break;
	 case MTLO:
		 //strcpy(OC,"MTLO");
		 LO=GPR[Ops.rs];
		 PC=PC+4;
		 return 0;
		 break;
	 case MULT:
		 strcpy(OC,"MULT");
		 PC=PC+4;
		 return -1;
		 break;
	 case MULTU:
		 strcpy(OC,"MULTU");
		 PC=PC+4;
		 return -1;
		 break;
	 case 39:
		 // Below is Adi's emulation of NOR
		 //strcpy(OC,"NOR");
         ((GPR[Ops.rd] != GPR[Ops.rs]) | (GPR[Ops.rd] != GPR[Ops.rt]));
		 PC=PC+4;
		 return 0;
		 break;
	 case OR:
		 //strcpy(OC,"OR");
         GPR[Ops.rd]=(GPR[Ops.rs] | GPR[Ops.rt]);
		 PC=PC+4;
		 return 0;
		 break;
	 case 0:
		 // SLL or NOP
		 if((Ops.rd==0) && (Ops.rt==0) && (Ops.sa==0))
		 {
			//strcpy(OC,"NOP");
			PC=PC+4;
			break;
		 }
		 else
		 {
			//strcpy(OC,"SLL");
			GPR[Ops.rd]=GPR[Ops.rt] << Ops.sa;
		 }
		 PC=PC+4;
		 return 0;
		 break;
	 case 4:
		 //strcpy(OC,"SLLV");
		 PC=PC+4;
		 GPR[Ops.rd]=GPR[Ops.rt] << Ops.rs;
		 return 0;
		 break;
	 case 42:
		 //strcpy(OC,"SLT"); // - Emulated by SubIce
		 PC=PC+4;
		 if(GPR[Ops.rs] < GPR[Ops.rt])
		 {
			 GPR[Ops.rd]=1;
		 }
		 else
		 {
			 GPR[Ops.rd]=0;
		 }
		 return 0;
		 break;
	 case 43:
		 //strcpy(OC,"SLTU"); //- Emulated by SubIce
		 PC=PC+4;
		 if((unsigned)GPR[Ops.rs] < (unsigned)GPR[Ops.rt])
		 {
			 GPR[Ops.rd]=1;
		 }
		 else
		 {
			 GPR[Ops.rd]=0;
		 }
		 return 0;
		 break;
	 case 3:
		 strcpy(OC,"SRA");
		 PC=PC+4;
		 return -1;
		 break;
	 case 7:
		 //strcpy(OC,"SRAV");
		 PC=PC+4;
		 GPR[Ops.rd]=GPR[Ops.rt] >> (int)GPR[Ops.rs];
		 return 0;
		 break;
	 case 2:
		 strcpy(OC,"SRL");
		 PC=PC+4;
		 return -1;
		 break;
	 case 6:
		 strcpy(OC,"SRLV");
		 PC=PC+4;
		 return -1;
		 break;
	 case 34:
		 strcpy(OC,"SUB");
		 PC=PC+4;
		 return -1;
		 break;
	 case 35:
		 strcpy(OC,"SUBU");
		 PC=PC+4;
		 return -1;
		 break;
	 case XOR:
		 //strcpy(OC,"XOR");
		 GPR[Ops.rd]=GPR[Ops.rs] ^ GPR[Ops.rt];
		 PC=PC+4;
		 return 0;
		 break;
	 case 9:
		 strcpy(OC,"JALR");
		 PC=PC+4;
		 return -1;
		 break;
	 case 8:
		 strcpy(OC,"JR");
         PC=(_int32)GPR[Ops.rs];
		 return 0;
		 break;
	 case BREAK:
		 strcpy(OC,"BREAK");
		 PC=PC+4;
		 return -1;
		 break;
	 case 12:
		 strcpy(OC,"SYSCALL");
		 PC=PC+4;
		 return -1;
		 break;
	 case 52:
		 strcpy(OC,"TEQ");
		 PC=PC+4;
		 return -1;
		 break;
	 case 48:
		 strcpy(OC,"TGE");
		 PC=PC+4;
		 return -1;
		 break;
	 case 49:
		 strcpy(OC,"TGEU");
		 PC=PC+4;
		 return -1;
		 break;
	 case 50:
		 strcpy(OC,"TLT");
		 PC=PC+4;
		 return -1;
		 break;
	 case 51:
		 strcpy(OC,"TLTU");
		 PC=PC+4;
		 return -1;
		 break;
	 case 54:
		 strcpy(OC,"TNE");
		 PC=PC+4;
		 return -1;
		 break;
	 }
	 break;
 default:
	 strcpy(OC, "Unknown");
	 if(STOP_OP)
	 {
	 sprintf(text,"Unknown opcode: %x\n Emulation stopped at instruction number %d",(Ops.op),CP0[9]+1);
	 MessageBox(hWndMain,text, "Unknown Opcode",MB_OK);
	 N64isRunning=0;
	 PC=PC+4;
	 return -1;
	 }
	 break;
 }
 return 0;
}
